/**********************************************************************
Copyright (c) 2005 IBM Corporation and others.
All rights reserved.  This program and the accompanying materials
are made available under the terms of the Eclipse Public License v1.0
which accompanies this distribution, and is available at
http://www.eclipse.org/legal/epl-v10.html
$Id: RaTa.java,v 1.5 2005/02/16 22:19:54 qiyanli Exp $

Contributors:
 IBM Rational - initial implementation
**********************************************************************/
package org.eclipse.hyades.collection.threadanalyzer;

import java.io.File;
import java.io.IOException;



public class RaTa
{
    private DumpData _dumpData = null;

    public static void main( String args[] )
    {
        RaTa myRaTa = new RaTa(args);
    }

    public RaTa( String args[] )
    {
        try
        {
            File dumpIn   = new File( args[0] );
            File dumpData = File.createTempFile( "tadump", ".dumpdata" );
            dumpData.deleteOnExit();

            String parseargs[] = 
            {
                "dumpIn=" + dumpIn.getCanonicalPath(),
                "streamOut=" + dumpData.getCanonicalPath(),
                "loglevel=error"
            };

//            System.out.println( parseargs[0] + "\n" + parseargs[1] + "\n" + parseargs[2] );

            
            org.eclipse.hyades.collection.threadanalyzer.dumpparser.DumpParser.main( parseargs );

            _dumpData = DumpData.readFrom( dumpData.getCanonicalPath() );

            _dumpData.initAnalysis();
            _dumpData._fHtml = false;
//            _dumpData.outputVector( _dumpData.servletMonitorAnalysis() );

        }
        catch ( IOException ioe )
        {
            ioe.printStackTrace();
        }
        catch ( Exception e )
        {
            e.printStackTrace();
        } 
    }

    public DumpData getDumpData()
    {
        return _dumpData;
    }
}
