/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: LogUIConstants.java,v 1.15 2005/05/06 04:06:50 popescu Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

package org.eclipse.hyades.log.ui.internal.util;

import org.eclipse.hyades.log.ui.internal.LogUIPlugin;

public class LogUIConstants {

	// Constants for Log Analyzer format preferences page.

	public static final String DATE_FORMAT_FULL   = LogUIPlugin.getResourceString("LOG_ANALYZER_FORMAT_PREF_PAGE_DATE_FULL");
	public static final String DATE_FORMAT_LONG   = LogUIPlugin.getResourceString("LOG_ANALYZER_FORMAT_PREF_PAGE_DATE_LONG");
	public static final String DATE_FORMAT_MEDIUM =	LogUIPlugin.getResourceString("LOG_ANALYZER_FORMAT_PREF_PAGE_DATE_MEDIUM");
	public static final String DATE_FORMAT_SHORT  = LogUIPlugin.getResourceString("LOG_ANALYZER_FORMAT_PREF_PAGE_DATE_SHORT");
	
	public static final String TIME_FORMAT_FULL   = LogUIPlugin.getResourceString("LOG_ANALYZER_FORMAT_PREF_PAGE_TIME_FULL");
	public static final String TIME_FORMAT_LONG   = LogUIPlugin.getResourceString("LOG_ANALYZER_FORMAT_PREF_PAGE_TIME_LONG");
	public static final String TIME_FORMAT_MEDIUM = LogUIPlugin.getResourceString("LOG_ANALYZER_FORMAT_PREF_PAGE_TIME_MEDIUM");
	public static final String TIME_FORMAT_SHORT  = LogUIPlugin.getResourceString("LOG_ANALYZER_FORMAT_PREF_PAGE_TIME_SHORT");
	
	public static final String LOG_ANALYZER_FORMAT_DATE_DEFAULT = DATE_FORMAT_MEDIUM;
	public static final String LOG_ANALYZER_FORMAT_TIME_DEFAULT = TIME_FORMAT_MEDIUM;
	public static final String LOG_ANALYZER_FORMAT_DATE = "LogAnalyzer.DateFormat";
	public static final String LOG_ANALYZER_FORMAT_TIME = "LogAnalyzer.TimeFormat";

	public static final String[] DATE_FORMAT_LIST =
	{	DATE_FORMAT_FULL,
		DATE_FORMAT_LONG,
		DATE_FORMAT_MEDIUM,
		DATE_FORMAT_SHORT };
	public static final String[] TIME_FORMAT_LIST =
	{	TIME_FORMAT_FULL,
		TIME_FORMAT_LONG,
		TIME_FORMAT_MEDIUM,
		TIME_FORMAT_SHORT };


	public static final String PD_FILTER_OPTIONS = "pd_filter_options";
	public static final String PD_ADV_FILTER_OPTIONS = "pd_adv_filter_options";
	public static final String PD_SEARCH_FILTER_OPTIONS = "pd_src_filter_options";
	public static final String PD_SEARCH_DIRECTION_OPTIONS = "pd_src_direction_options";
	public static final String PD_SEV_OPTIONS = "pd_sev_options";
	public static final String PD_SORT_LOG_OPTIONS = "pd_sort_log_options";
	public static final String PD_SORT_COLUMNS_LIST = "pd_sort_columns_list";

	public static final String LOG_ANALYZER_PRJ = "LogAnalyzerProject";
		
	public static final String LOG_IMPORT="logImports";
	
	public static final String PD_FILTER_SHOW_CORRELATION_ONLY = "pd_filter_show_correlation_only";
	public static final int FILTER_LOG_VIEW = 0;
	public static final int FILTER_LOG_INTER = 1;
	public static final int SEARCH = 2;
	public static final int XMI = 0;
	public static final int SQL = 1;


	public static final String CONST_CBES_HEADER = "<CommonBaseEvents xmlns=\"http://www.ibm.com/AC/commonbaseevent1_0_1\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://www.ibm.com/AC/commonbaseevent1_0_1 commonbaseevent1_0_1.xsd\">";
	public static final String CONST_CBES_FOOTER = "</CommonBaseEvents>";

}