/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: OutputterPackage.java,v 1.9 2005/03/24 21:12:26 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.logging.adapter.model.internal.outputter;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.hyades.logging.adapter.model.internal.unit.UnitPackage;

import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * <!-- begin-model-doc -->
 * 
 *         Copyright (c) 2005 IBM Corporation and others.
 *         All rights reserved.   This program and the accompanying materials
 *         are made available under the terms of the Eclipse Public License v1.0
 *         which accompanies this distribution, and is available at
 *         http://www.eclipse.org/legal/epl-v10.html
 *       
 * 
 *           Copyright (c) 2005 IBM Corporation and others.
 *           All rights reserved.   This program and the accompanying materials
 *           are made available under the terms of the Eclipse Public License v1.0
 *           which accompanies this distribution, and is available at
 *           http://www.eclipse.org/legal/epl-v10.html
 *         
 * <!-- end-model-doc -->
 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterFactory
 * @generated
 */
public interface OutputterPackage extends EPackage{
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "outputter";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.eclipse.org/hyades/schema/Outputter.xsd";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "op";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	OutputterPackage eINSTANCE = org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.OutputterPackageImpl.init();

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.LoggingAgentOutputterTypeTypeImpl <em>Logging Agent Outputter Type Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.LoggingAgentOutputterTypeTypeImpl
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.OutputterPackageImpl#getLoggingAgentOutputterTypeType()
	 * @generated
	 */
	int LOGGING_AGENT_OUTPUTTER_TYPE_TYPE = 0;

	/**
	 * The feature id for the '<em><b>Agent Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOGGING_AGENT_OUTPUTTER_TYPE_TYPE__AGENT_NAME = 0;

	/**
	 * The feature id for the '<em><b>Wait Until Logging Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOGGING_AGENT_OUTPUTTER_TYPE_TYPE__WAIT_UNTIL_LOGGING_TIME = 1;

	/**
	 * The number of structural features of the the '<em>Logging Agent Outputter Type Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOGGING_AGENT_OUTPUTTER_TYPE_TYPE_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.NotificationOutputterTypeTypeImpl <em>Notification Outputter Type Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.NotificationOutputterTypeTypeImpl
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.OutputterPackageImpl#getNotificationOutputterTypeType()
	 * @generated
	 */
	int NOTIFICATION_OUTPUTTER_TYPE_TYPE = 1;

	/**
	 * The feature id for the '<em><b>Resource URL</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NOTIFICATION_OUTPUTTER_TYPE_TYPE__RESOURCE_URL = 0;

	/**
	 * The number of structural features of the the '<em>Notification Outputter Type Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NOTIFICATION_OUTPUTTER_TYPE_TYPE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.OutputterConfigTypeImpl <em>Config Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.OutputterConfigTypeImpl
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.OutputterPackageImpl#getOutputterConfigType()
	 * @generated
	 */
	int OUTPUTTER_CONFIG_TYPE = 2;

	/**
	 * The feature id for the '<em><b>Property</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUTTER_CONFIG_TYPE__PROPERTY = UnitPackage.PROCESS_UNIT_TYPE__PROPERTY;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUTTER_CONFIG_TYPE__DESCRIPTION = UnitPackage.PROCESS_UNIT_TYPE__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Unique ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUTTER_CONFIG_TYPE__UNIQUE_ID = UnitPackage.PROCESS_UNIT_TYPE__UNIQUE_ID;

	/**
	 * The feature id for the '<em><b>Single File Outputter Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUTTER_CONFIG_TYPE__SINGLE_FILE_OUTPUTTER_TYPE = UnitPackage.PROCESS_UNIT_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Standard Out Outputter Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUTTER_CONFIG_TYPE__STANDARD_OUT_OUTPUTTER_TYPE = UnitPackage.PROCESS_UNIT_TYPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Logging Agent Outputter Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUTTER_CONFIG_TYPE__LOGGING_AGENT_OUTPUTTER_TYPE = UnitPackage.PROCESS_UNIT_TYPE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Notification Outputter Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUTTER_CONFIG_TYPE__NOTIFICATION_OUTPUTTER_TYPE = UnitPackage.PROCESS_UNIT_TYPE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUTTER_CONFIG_TYPE__TYPE = UnitPackage.PROCESS_UNIT_TYPE_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the the '<em>Config Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OUTPUTTER_CONFIG_TYPE_FEATURE_COUNT = UnitPackage.PROCESS_UNIT_TYPE_FEATURE_COUNT + 5;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.SingleFileOutputterTypeTypeImpl <em>Single File Outputter Type Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.SingleFileOutputterTypeTypeImpl
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.OutputterPackageImpl#getSingleFileOutputterTypeType()
	 * @generated
	 */
	int SINGLE_FILE_OUTPUTTER_TYPE_TYPE = 3;

	/**
	 * The feature id for the '<em><b>Directory</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SINGLE_FILE_OUTPUTTER_TYPE_TYPE__DIRECTORY = 0;

	/**
	 * The feature id for the '<em><b>File Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SINGLE_FILE_OUTPUTTER_TYPE_TYPE__FILE_NAME = 1;

	/**
	 * The number of structural features of the the '<em>Single File Outputter Type Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SINGLE_FILE_OUTPUTTER_TYPE_TYPE_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.StandardOutOutputterTypeTypeImpl <em>Standard Out Outputter Type Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.StandardOutOutputterTypeTypeImpl
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.OutputterPackageImpl#getStandardOutOutputterTypeType()
	 * @generated
	 */
	int STANDARD_OUT_OUTPUTTER_TYPE_TYPE = 4;

	/**
	 * The number of structural features of the the '<em>Standard Out Outputter Type Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STANDARD_OUT_OUTPUTTER_TYPE_TYPE_FEATURE_COUNT = 0;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.DocumentRootImpl <em>Document Root</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.DocumentRootImpl
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.OutputterPackageImpl#getDocumentRoot()
	 * @generated
	 */
	int DOCUMENT_ROOT = 5;

	/**
	 * The feature id for the '<em><b>Mixed</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__MIXED = 0;

	/**
	 * The feature id for the '<em><b>XMLNS Prefix Map</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__XMLNS_PREFIX_MAP = 1;

	/**
	 * The feature id for the '<em><b>XSI Schema Location</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__XSI_SCHEMA_LOCATION = 2;

	/**
	 * The feature id for the '<em><b>Logging Agent Outputter Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__LOGGING_AGENT_OUTPUTTER_TYPE = 3;

	/**
	 * The feature id for the '<em><b>Notification Outputter Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__NOTIFICATION_OUTPUTTER_TYPE = 4;

	/**
	 * The feature id for the '<em><b>Single File Outputter Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__SINGLE_FILE_OUTPUTTER_TYPE = 5;

	/**
	 * The feature id for the '<em><b>Standard Out Outputter Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__STANDARD_OUT_OUTPUTTER_TYPE = 6;

	/**
	 * The number of structural features of the the '<em>Document Root</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT_FEATURE_COUNT = 7;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterType <em>Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterType
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.OutputterPackageImpl#getOutputterType()
	 * @generated
	 */
	int OUTPUTTER_TYPE = 6;

	/**
	 * The meta object id for the '<em>Type Object</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterType
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.OutputterPackageImpl#getOutputterTypeObject()
	 * @generated
	 */
	int OUTPUTTER_TYPE_OBJECT = 7;


	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.LoggingAgentOutputterTypeType <em>Logging Agent Outputter Type Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Logging Agent Outputter Type Type</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.LoggingAgentOutputterTypeType
	 * @generated
	 */
	EClass getLoggingAgentOutputterTypeType();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.LoggingAgentOutputterTypeType#getAgentName <em>Agent Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Agent Name</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.LoggingAgentOutputterTypeType#getAgentName()
	 * @see #getLoggingAgentOutputterTypeType()
	 * @generated
	 */
	EAttribute getLoggingAgentOutputterTypeType_AgentName();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.LoggingAgentOutputterTypeType#getWaitUntilLoggingTime <em>Wait Until Logging Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Wait Until Logging Time</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.LoggingAgentOutputterTypeType#getWaitUntilLoggingTime()
	 * @see #getLoggingAgentOutputterTypeType()
	 * @generated
	 */
	EAttribute getLoggingAgentOutputterTypeType_WaitUntilLoggingTime();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.NotificationOutputterTypeType <em>Notification Outputter Type Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Notification Outputter Type Type</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.NotificationOutputterTypeType
	 * @generated
	 */
	EClass getNotificationOutputterTypeType();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.NotificationOutputterTypeType#getResourceURL <em>Resource URL</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Resource URL</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.NotificationOutputterTypeType#getResourceURL()
	 * @see #getNotificationOutputterTypeType()
	 * @generated
	 */
	EAttribute getNotificationOutputterTypeType_ResourceURL();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterConfigType <em>Config Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Config Type</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterConfigType
	 * @generated
	 */
	EClass getOutputterConfigType();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterConfigType#getSingleFileOutputterType <em>Single File Outputter Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Single File Outputter Type</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterConfigType#getSingleFileOutputterType()
	 * @see #getOutputterConfigType()
	 * @generated
	 */
	EReference getOutputterConfigType_SingleFileOutputterType();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterConfigType#getStandardOutOutputterType <em>Standard Out Outputter Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Standard Out Outputter Type</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterConfigType#getStandardOutOutputterType()
	 * @see #getOutputterConfigType()
	 * @generated
	 */
	EReference getOutputterConfigType_StandardOutOutputterType();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterConfigType#getLoggingAgentOutputterType <em>Logging Agent Outputter Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Logging Agent Outputter Type</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterConfigType#getLoggingAgentOutputterType()
	 * @see #getOutputterConfigType()
	 * @generated
	 */
	EReference getOutputterConfigType_LoggingAgentOutputterType();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterConfigType#getNotificationOutputterType <em>Notification Outputter Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Notification Outputter Type</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterConfigType#getNotificationOutputterType()
	 * @see #getOutputterConfigType()
	 * @generated
	 */
	EReference getOutputterConfigType_NotificationOutputterType();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterConfigType#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterConfigType#getType()
	 * @see #getOutputterConfigType()
	 * @generated
	 */
	EAttribute getOutputterConfigType_Type();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.SingleFileOutputterTypeType <em>Single File Outputter Type Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Single File Outputter Type Type</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.SingleFileOutputterTypeType
	 * @generated
	 */
	EClass getSingleFileOutputterTypeType();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.SingleFileOutputterTypeType#getDirectory <em>Directory</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Directory</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.SingleFileOutputterTypeType#getDirectory()
	 * @see #getSingleFileOutputterTypeType()
	 * @generated
	 */
	EAttribute getSingleFileOutputterTypeType_Directory();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.SingleFileOutputterTypeType#getFileName <em>File Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>File Name</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.SingleFileOutputterTypeType#getFileName()
	 * @see #getSingleFileOutputterTypeType()
	 * @generated
	 */
	EAttribute getSingleFileOutputterTypeType_FileName();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.StandardOutOutputterTypeType <em>Standard Out Outputter Type Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Standard Out Outputter Type Type</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.StandardOutOutputterTypeType
	 * @generated
	 */
	EClass getStandardOutOutputterTypeType();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot <em>Document Root</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Document Root</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot
	 * @generated
	 */
	EClass getDocumentRoot();

	/**
	 * Returns the meta object for the attribute list '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot#getMixed <em>Mixed</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Mixed</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot#getMixed()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EAttribute getDocumentRoot_Mixed();

	/**
	 * Returns the meta object for the map '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot#getXMLNSPrefixMap <em>XMLNS Prefix Map</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the map '<em>XMLNS Prefix Map</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot#getXMLNSPrefixMap()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_XMLNSPrefixMap();

	/**
	 * Returns the meta object for the map '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot#getXSISchemaLocation <em>XSI Schema Location</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the map '<em>XSI Schema Location</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot#getXSISchemaLocation()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_XSISchemaLocation();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot#getLoggingAgentOutputterType <em>Logging Agent Outputter Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Logging Agent Outputter Type</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot#getLoggingAgentOutputterType()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_LoggingAgentOutputterType();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot#getNotificationOutputterType <em>Notification Outputter Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Notification Outputter Type</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot#getNotificationOutputterType()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_NotificationOutputterType();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot#getSingleFileOutputterType <em>Single File Outputter Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Single File Outputter Type</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot#getSingleFileOutputterType()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_SingleFileOutputterType();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot#getStandardOutOutputterType <em>Standard Out Outputter Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Standard Out Outputter Type</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot#getStandardOutOutputterType()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_StandardOutOutputterType();

	/**
	 * Returns the meta object for enum '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Type</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterType
	 * @generated
	 */
	EEnum getOutputterType();

	/**
	 * Returns the meta object for data type '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterType <em>Type Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>Type Object</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterType
	 * @model instanceClass="org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterType"
	 * @generated
	 */
	EDataType getOutputterTypeObject();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	OutputterFactory getOutputterFactory();

} //OutputterPackage
