/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: DocumentRootImpl.java,v 1.6 2005/03/24 21:12:27 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.logging.adapter.model.internal.outputter.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EMap;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.impl.EStringToStringMapEntryImpl;

import org.eclipse.emf.ecore.util.BasicFeatureMap;
import org.eclipse.emf.ecore.util.EcoreEMap;
import org.eclipse.emf.ecore.util.FeatureMap;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot;
import org.eclipse.hyades.logging.adapter.model.internal.outputter.LoggingAgentOutputterTypeType;
import org.eclipse.hyades.logging.adapter.model.internal.outputter.NotificationOutputterTypeType;
import org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterPackage;
import org.eclipse.hyades.logging.adapter.model.internal.outputter.SingleFileOutputterTypeType;
import org.eclipse.hyades.logging.adapter.model.internal.outputter.StandardOutOutputterTypeType;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Document Root</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.DocumentRootImpl#getMixed <em>Mixed</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.DocumentRootImpl#getXMLNSPrefixMap <em>XMLNS Prefix Map</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.DocumentRootImpl#getXSISchemaLocation <em>XSI Schema Location</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.DocumentRootImpl#getLoggingAgentOutputterType <em>Logging Agent Outputter Type</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.DocumentRootImpl#getNotificationOutputterType <em>Notification Outputter Type</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.DocumentRootImpl#getSingleFileOutputterType <em>Single File Outputter Type</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.DocumentRootImpl#getStandardOutOutputterType <em>Standard Out Outputter Type</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class DocumentRootImpl extends EObjectImpl implements DocumentRoot {
	/**
	 * The cached value of the '{@link #getMixed() <em>Mixed</em>}' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMixed()
	 * @generated
	 * @ordered
	 */
	protected FeatureMap mixed = null;

	/**
	 * The cached value of the '{@link #getXMLNSPrefixMap() <em>XMLNS Prefix Map</em>}' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getXMLNSPrefixMap()
	 * @generated
	 * @ordered
	 */
	protected EMap xMLNSPrefixMap = null;

	/**
	 * The cached value of the '{@link #getXSISchemaLocation() <em>XSI Schema Location</em>}' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getXSISchemaLocation()
	 * @generated
	 * @ordered
	 */
	protected EMap xSISchemaLocation = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DocumentRootImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return OutputterPackage.eINSTANCE.getDocumentRoot();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FeatureMap getMixed() {
		if (mixed == null) {
			mixed = new BasicFeatureMap(this, OutputterPackage.DOCUMENT_ROOT__MIXED);
		}
		return mixed;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EMap getXMLNSPrefixMap() {
		if (xMLNSPrefixMap == null) {
			xMLNSPrefixMap = new EcoreEMap(EcorePackage.eINSTANCE.getEStringToStringMapEntry(), EStringToStringMapEntryImpl.class, this, OutputterPackage.DOCUMENT_ROOT__XMLNS_PREFIX_MAP);
		}
		return xMLNSPrefixMap;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EMap getXSISchemaLocation() {
		if (xSISchemaLocation == null) {
			xSISchemaLocation = new EcoreEMap(EcorePackage.eINSTANCE.getEStringToStringMapEntry(), EStringToStringMapEntryImpl.class, this, OutputterPackage.DOCUMENT_ROOT__XSI_SCHEMA_LOCATION);
		}
		return xSISchemaLocation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LoggingAgentOutputterTypeType getLoggingAgentOutputterType() {
		return (LoggingAgentOutputterTypeType)getMixed().get(OutputterPackage.eINSTANCE.getDocumentRoot_LoggingAgentOutputterType(), true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetLoggingAgentOutputterType(LoggingAgentOutputterTypeType newLoggingAgentOutputterType, NotificationChain msgs) {
		return ((FeatureMap.Internal)getMixed()).basicAdd(OutputterPackage.eINSTANCE.getDocumentRoot_LoggingAgentOutputterType(), newLoggingAgentOutputterType, null);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLoggingAgentOutputterType(LoggingAgentOutputterTypeType newLoggingAgentOutputterType) {
		((FeatureMap.Internal)getMixed()).set(OutputterPackage.eINSTANCE.getDocumentRoot_LoggingAgentOutputterType(), newLoggingAgentOutputterType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationOutputterTypeType getNotificationOutputterType() {
		return (NotificationOutputterTypeType)getMixed().get(OutputterPackage.eINSTANCE.getDocumentRoot_NotificationOutputterType(), true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetNotificationOutputterType(NotificationOutputterTypeType newNotificationOutputterType, NotificationChain msgs) {
		return ((FeatureMap.Internal)getMixed()).basicAdd(OutputterPackage.eINSTANCE.getDocumentRoot_NotificationOutputterType(), newNotificationOutputterType, null);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setNotificationOutputterType(NotificationOutputterTypeType newNotificationOutputterType) {
		((FeatureMap.Internal)getMixed()).set(OutputterPackage.eINSTANCE.getDocumentRoot_NotificationOutputterType(), newNotificationOutputterType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SingleFileOutputterTypeType getSingleFileOutputterType() {
		return (SingleFileOutputterTypeType)getMixed().get(OutputterPackage.eINSTANCE.getDocumentRoot_SingleFileOutputterType(), true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetSingleFileOutputterType(SingleFileOutputterTypeType newSingleFileOutputterType, NotificationChain msgs) {
		return ((FeatureMap.Internal)getMixed()).basicAdd(OutputterPackage.eINSTANCE.getDocumentRoot_SingleFileOutputterType(), newSingleFileOutputterType, null);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSingleFileOutputterType(SingleFileOutputterTypeType newSingleFileOutputterType) {
		((FeatureMap.Internal)getMixed()).set(OutputterPackage.eINSTANCE.getDocumentRoot_SingleFileOutputterType(), newSingleFileOutputterType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public StandardOutOutputterTypeType getStandardOutOutputterType() {
		return (StandardOutOutputterTypeType)getMixed().get(OutputterPackage.eINSTANCE.getDocumentRoot_StandardOutOutputterType(), true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetStandardOutOutputterType(StandardOutOutputterTypeType newStandardOutOutputterType, NotificationChain msgs) {
		return ((FeatureMap.Internal)getMixed()).basicAdd(OutputterPackage.eINSTANCE.getDocumentRoot_StandardOutOutputterType(), newStandardOutOutputterType, null);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStandardOutOutputterType(StandardOutOutputterTypeType newStandardOutOutputterType) {
		((FeatureMap.Internal)getMixed()).set(OutputterPackage.eINSTANCE.getDocumentRoot_StandardOutOutputterType(), newStandardOutOutputterType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case OutputterPackage.DOCUMENT_ROOT__MIXED:
					return ((InternalEList)getMixed()).basicRemove(otherEnd, msgs);
				case OutputterPackage.DOCUMENT_ROOT__XMLNS_PREFIX_MAP:
					return ((InternalEList)getXMLNSPrefixMap()).basicRemove(otherEnd, msgs);
				case OutputterPackage.DOCUMENT_ROOT__XSI_SCHEMA_LOCATION:
					return ((InternalEList)getXSISchemaLocation()).basicRemove(otherEnd, msgs);
				case OutputterPackage.DOCUMENT_ROOT__LOGGING_AGENT_OUTPUTTER_TYPE:
					return basicSetLoggingAgentOutputterType(null, msgs);
				case OutputterPackage.DOCUMENT_ROOT__NOTIFICATION_OUTPUTTER_TYPE:
					return basicSetNotificationOutputterType(null, msgs);
				case OutputterPackage.DOCUMENT_ROOT__SINGLE_FILE_OUTPUTTER_TYPE:
					return basicSetSingleFileOutputterType(null, msgs);
				case OutputterPackage.DOCUMENT_ROOT__STANDARD_OUT_OUTPUTTER_TYPE:
					return basicSetStandardOutOutputterType(null, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case OutputterPackage.DOCUMENT_ROOT__MIXED:
				return getMixed();
			case OutputterPackage.DOCUMENT_ROOT__XMLNS_PREFIX_MAP:
				return getXMLNSPrefixMap();
			case OutputterPackage.DOCUMENT_ROOT__XSI_SCHEMA_LOCATION:
				return getXSISchemaLocation();
			case OutputterPackage.DOCUMENT_ROOT__LOGGING_AGENT_OUTPUTTER_TYPE:
				return getLoggingAgentOutputterType();
			case OutputterPackage.DOCUMENT_ROOT__NOTIFICATION_OUTPUTTER_TYPE:
				return getNotificationOutputterType();
			case OutputterPackage.DOCUMENT_ROOT__SINGLE_FILE_OUTPUTTER_TYPE:
				return getSingleFileOutputterType();
			case OutputterPackage.DOCUMENT_ROOT__STANDARD_OUT_OUTPUTTER_TYPE:
				return getStandardOutOutputterType();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case OutputterPackage.DOCUMENT_ROOT__MIXED:
				getMixed().clear();
				getMixed().addAll((Collection)newValue);
				return;
			case OutputterPackage.DOCUMENT_ROOT__XMLNS_PREFIX_MAP:
				getXMLNSPrefixMap().clear();
				getXMLNSPrefixMap().addAll((Collection)newValue);
				return;
			case OutputterPackage.DOCUMENT_ROOT__XSI_SCHEMA_LOCATION:
				getXSISchemaLocation().clear();
				getXSISchemaLocation().addAll((Collection)newValue);
				return;
			case OutputterPackage.DOCUMENT_ROOT__LOGGING_AGENT_OUTPUTTER_TYPE:
				setLoggingAgentOutputterType((LoggingAgentOutputterTypeType)newValue);
				return;
			case OutputterPackage.DOCUMENT_ROOT__NOTIFICATION_OUTPUTTER_TYPE:
				setNotificationOutputterType((NotificationOutputterTypeType)newValue);
				return;
			case OutputterPackage.DOCUMENT_ROOT__SINGLE_FILE_OUTPUTTER_TYPE:
				setSingleFileOutputterType((SingleFileOutputterTypeType)newValue);
				return;
			case OutputterPackage.DOCUMENT_ROOT__STANDARD_OUT_OUTPUTTER_TYPE:
				setStandardOutOutputterType((StandardOutOutputterTypeType)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case OutputterPackage.DOCUMENT_ROOT__MIXED:
				getMixed().clear();
				return;
			case OutputterPackage.DOCUMENT_ROOT__XMLNS_PREFIX_MAP:
				getXMLNSPrefixMap().clear();
				return;
			case OutputterPackage.DOCUMENT_ROOT__XSI_SCHEMA_LOCATION:
				getXSISchemaLocation().clear();
				return;
			case OutputterPackage.DOCUMENT_ROOT__LOGGING_AGENT_OUTPUTTER_TYPE:
				setLoggingAgentOutputterType((LoggingAgentOutputterTypeType)null);
				return;
			case OutputterPackage.DOCUMENT_ROOT__NOTIFICATION_OUTPUTTER_TYPE:
				setNotificationOutputterType((NotificationOutputterTypeType)null);
				return;
			case OutputterPackage.DOCUMENT_ROOT__SINGLE_FILE_OUTPUTTER_TYPE:
				setSingleFileOutputterType((SingleFileOutputterTypeType)null);
				return;
			case OutputterPackage.DOCUMENT_ROOT__STANDARD_OUT_OUTPUTTER_TYPE:
				setStandardOutOutputterType((StandardOutOutputterTypeType)null);
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case OutputterPackage.DOCUMENT_ROOT__MIXED:
				return mixed != null && !mixed.isEmpty();
			case OutputterPackage.DOCUMENT_ROOT__XMLNS_PREFIX_MAP:
				return xMLNSPrefixMap != null && !xMLNSPrefixMap.isEmpty();
			case OutputterPackage.DOCUMENT_ROOT__XSI_SCHEMA_LOCATION:
				return xSISchemaLocation != null && !xSISchemaLocation.isEmpty();
			case OutputterPackage.DOCUMENT_ROOT__LOGGING_AGENT_OUTPUTTER_TYPE:
				return getLoggingAgentOutputterType() != null;
			case OutputterPackage.DOCUMENT_ROOT__NOTIFICATION_OUTPUTTER_TYPE:
				return getNotificationOutputterType() != null;
			case OutputterPackage.DOCUMENT_ROOT__SINGLE_FILE_OUTPUTTER_TYPE:
				return getSingleFileOutputterType() != null;
			case OutputterPackage.DOCUMENT_ROOT__STANDARD_OUT_OUTPUTTER_TYPE:
				return getStandardOutOutputterType() != null;
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (mixed: ");
		result.append(mixed);
		result.append(')');
		return result.toString();
	}

} //DocumentRootImpl
