/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: MissingValueException.java,v 1.5 2005/02/16 22:20:48 qiyanli Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

package org.eclipse.hyades.logging.events.exceptions;

/**
 * Exception to indicate that a value was not supplied for a
 * required attribute, when calling a method or creating an object.
 * 
 * @deprecated This class is deprecated as of 2004-05-17
 */
public class MissingValueException extends Exception
{

    private String attribName;

    /** Create a new MissingValueException.
     * 
     * @param attrName		The name of the attribute with the missing value.
     */

    public MissingValueException(String attrName)
    {
        this.attribName = attrName;
    }

    /** Get the name of the attribute with the missing value.
     * 
     * @return		The name of the attribute with the missing value.
     */
    public String getAttributeName()
    {
        return this.attribName;
    }

} /* end class MissingValueException */
