/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: SDView.java,v 1.7 2005/02/16 22:21:26 qiyanli Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.model.statistical;

import org.eclipse.emf.common.util.EList;
import org.eclipse.hyades.models.hierarchy.AbstractTRCView;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>SD View</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The view is a named collection of windows.  The view allows you to navigate the windows so that data can be propogated through the windows if that behaviour is desired.
 * For example data may be collected at 1 minute intervals and used to populate a widow which contains the most recent 1 hour of data. There may be a second window that contains a set of data point that summarize each of the previous 23 hours plus the hour represented in the first window. A third window may reflect the data for a given week, and so on.
 * A view associates these windows of related data and provides a mechanism to manage the cascading of data across these windows over the data.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.model.statistical.SDView#getName <em>Name</em>}</li>
 *   <li>{@link org.eclipse.hyades.model.statistical.SDView#getWindow <em>Window</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.model.statistical.StatisticalPackage#getSDView()
 * @model 
 * @generated
 */
public interface SDView extends AbstractTRCView{
	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see org.eclipse.hyades.model.statistical.StatisticalPackage#getSDView_Name()
	 * @model 
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.model.statistical.SDView#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Window</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.hyades.model.statistical.SDSampleWindow}.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.model.statistical.SDSampleWindow#getView <em>View</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Window</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Window</em>' containment reference list.
	 * @see org.eclipse.hyades.model.statistical.StatisticalPackage#getSDView_Window()
	 * @see org.eclipse.hyades.model.statistical.SDSampleWindow#getView
	 * @model type="org.eclipse.hyades.model.statistical.SDSampleWindow" opposite="view" containment="true"
	 * @generated
	 */
	EList getWindow();

} // SDView
