/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: TPFInvocationReason.java,v 1.10 2005/03/28 21:51:31 jptoomey Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.common.testprofile;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.MissingResourceException;

import org.eclipse.emf.common.util.AbstractEnumerator;

import org.eclipse.hyades.models.common.common.CommonPlugin;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>TPF Invocation Reason</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFInvocationReason()
 * @model
 * @generated
 */
public final class TPFInvocationReason extends AbstractEnumerator
{
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "";

	/**
	 * The '<em><b>Unknown</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #UNKNOWN_LITERAL
	 * @model name="unknown"
	 * @generated
	 * @ordered
	 */
	public static final int UNKNOWN = 0;

	/**
	 * The '<em><b>None</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #NONE_LITERAL
	 * @model name="none"
	 * @generated
	 * @ordered
	 */
	public static final int NONE = 1;

	/**
	 * The '<em><b>See Description</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SEE_DESCRIPTION_LITERAL
	 * @model name="seeDescription"
	 * @generated
	 * @ordered
	 */
	public static final int SEE_DESCRIPTION = 2;

	/**
	 * The '<em><b>Precondition Not Met</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #PRECONDITION_NOT_MET_LITERAL
	 * @model name="preconditionNotMet"
	 * @generated
	 * @ordered
	 */
	public static final int PRECONDITION_NOT_MET = 3;

	/**
	 * The '<em><b>No Matching Configuration</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #NO_MATCHING_CONFIGURATION_LITERAL
	 * @model name="noMatchingConfiguration"
	 * @generated
	 * @ordered
	 */
	public static final int NO_MATCHING_CONFIGURATION = 4;

	/**
	 * The '<em><b>No Behavior</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #NO_BEHAVIOR_LITERAL
	 * @model name="noBehavior"
	 * @generated
	 * @ordered
	 */
	public static final int NO_BEHAVIOR = 5;

	/**
	 * The '<em><b>Did Not Start</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #DID_NOT_START_LITERAL
	 * @model name="didNotStart"
	 * @generated
	 * @ordered
	 */
	public static final int DID_NOT_START = 6;

	/**
	 * The '<em><b>Unknown</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Unknown</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #UNKNOWN
	 * @generated
	 * @ordered
	 */
	public static final TPFInvocationReason UNKNOWN_LITERAL = new TPFInvocationReason(UNKNOWN, "unknown");

	/**
	 * The '<em><b>None</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>None</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #NONE
	 * @generated
	 * @ordered
	 */
	public static final TPFInvocationReason NONE_LITERAL = new TPFInvocationReason(NONE, "none");

	/**
	 * The '<em><b>See Description</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>See Description</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #SEE_DESCRIPTION
	 * @generated
	 * @ordered
	 */
	public static final TPFInvocationReason SEE_DESCRIPTION_LITERAL = new TPFInvocationReason(SEE_DESCRIPTION, "seeDescription");

	/**
	 * The '<em><b>Precondition Not Met</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Precondition Not Met</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #PRECONDITION_NOT_MET
	 * @generated
	 * @ordered
	 */
	public static final TPFInvocationReason PRECONDITION_NOT_MET_LITERAL = new TPFInvocationReason(PRECONDITION_NOT_MET, "preconditionNotMet");

	/**
	 * The '<em><b>No Matching Configuration</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>No Matching Configuration</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #NO_MATCHING_CONFIGURATION
	 * @generated
	 * @ordered
	 */
	public static final TPFInvocationReason NO_MATCHING_CONFIGURATION_LITERAL = new TPFInvocationReason(NO_MATCHING_CONFIGURATION, "noMatchingConfiguration");

	/**
	 * The '<em><b>No Behavior</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>No Behavior</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #NO_BEHAVIOR
	 * @generated
	 * @ordered
	 */
	public static final TPFInvocationReason NO_BEHAVIOR_LITERAL = new TPFInvocationReason(NO_BEHAVIOR, "noBehavior");

	/**
	 * The '<em><b>Did Not Start</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Did Not Start</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #DID_NOT_START
	 * @generated
	 * @ordered
	 */
	public static final TPFInvocationReason DID_NOT_START_LITERAL = new TPFInvocationReason(DID_NOT_START, "didNotStart");

	/**
	 * An array of all the '<em><b>TPF Invocation Reason</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final TPFInvocationReason[] VALUES_ARRAY =
		new TPFInvocationReason[] {
			UNKNOWN_LITERAL,
			NONE_LITERAL,
			SEE_DESCRIPTION_LITERAL,
			PRECONDITION_NOT_MET_LITERAL,
			NO_MATCHING_CONFIGURATION_LITERAL,
			NO_BEHAVIOR_LITERAL,
			DID_NOT_START_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>TPF Invocation Reason</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>TPF Invocation Reason</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static TPFInvocationReason get(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			TPFInvocationReason result = VALUES_ARRAY[i];
			if (result.toString().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>TPF Invocation Reason</b></em>' literal with the specified value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static TPFInvocationReason get(int value) {
		switch (value) {
			case UNKNOWN: return UNKNOWN_LITERAL;
			case NONE: return NONE_LITERAL;
			case SEE_DESCRIPTION: return SEE_DESCRIPTION_LITERAL;
			case PRECONDITION_NOT_MET: return PRECONDITION_NOT_MET_LITERAL;
			case NO_MATCHING_CONFIGURATION: return NO_MATCHING_CONFIGURATION_LITERAL;
			case NO_BEHAVIOR: return NO_BEHAVIOR_LITERAL;
			case DID_NOT_START: return DID_NOT_START_LITERAL;
		}
		return null;	
	}

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private TPFInvocationReason(int value, String name) {
		super(value, name);
	}

	/**
	 * Returns the enumeration value associated with a 
	 * label.
	 * 
	 * <p>If the label is not valid then this method
	 * returns the default value for the enumeration.
	 * 
	 * @param label
	 * @return TPFInvocationReason
	 */
	public static TPFInvocationReason getByLabel(String label)
	{
		if(label != null)
		{
			for (int i = 0, maxi=VALUES_ARRAY.length; i < maxi; i++)
			{
				if(label.equals(VALUES_ARRAY[i].getLabel()))
					return VALUES_ARRAY[i];
			}
		}
		return get(label);	
	}
	
	private final String keyPrefix = getClass().getName() + ".";
	
	/**
	 * Returns the label associated with this enumeration value.  If
	 * there is no label then this method returns the enumeration's name.
	 * @return String
	 */
	public String getLabel()
	{
		try
		{
			String label = getString(keyPrefix + getName());
			if(label != null)
				return label;
		}
		catch(MissingResourceException e)
		{
		} 

		return getName();
	}
	
	/**
	 * Returns the string value associated with a given key.
	 * @param key
	 * @return String
	 * @throws java.util.MissingResourceException if the key is not in the file
	 * @throws NullPointerException if key is null
	 */
	protected String getString(String key)
	throws NullPointerException, MissingResourceException
	{
		return CommonPlugin.getString(key);
	}	
} //TPFInvocationReason
