/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: TPFVerdictEventImpl.java,v 1.13 2005/03/28 21:51:31 jptoomey Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.common.testprofile.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.hyades.models.common.interactions.BVRInteractionFragment;
import org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage;
import org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent;
import org.eclipse.hyades.models.common.testprofile.TPFExecutionHistory;
import org.eclipse.hyades.models.common.testprofile.TPFVerdict;
import org.eclipse.hyades.models.common.testprofile.TPFVerdictEvent;
import org.eclipse.hyades.models.common.testprofile.TPFVerdictReason;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>TPF Verdict Event</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.impl.TPFVerdictEventImpl#getVerdict <em>Verdict</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.impl.TPFVerdictEventImpl#getReason <em>Reason</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.impl.TPFVerdictEventImpl#getCausedBy <em>Caused By</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class TPFVerdictEventImpl extends TPFExecutionEventImpl implements TPFVerdictEvent
{
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "";

	/**
	 * The default value of the '{@link #getVerdict() <em>Verdict</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getVerdict()
	 * @generated
	 * @ordered
	 */
	protected static final TPFVerdict VERDICT_EDEFAULT = TPFVerdict.INCONCLUSIVE_LITERAL;

	/**
	 * The cached value of the '{@link #getVerdict() <em>Verdict</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getVerdict()
	 * @generated
	 * @ordered
	 */
	protected TPFVerdict verdict = VERDICT_EDEFAULT;

	/**
	 * The default value of the '{@link #getReason() <em>Reason</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReason()
	 * @generated
	 * @ordered
	 */
	protected static final TPFVerdictReason REASON_EDEFAULT = TPFVerdictReason.UNKNOWN_LITERAL;

	/**
	 * The cached value of the '{@link #getReason() <em>Reason</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReason()
	 * @generated
	 * @ordered
	 */
	protected TPFVerdictReason reason = REASON_EDEFAULT;

	/**
	 * The cached value of the '{@link #getCausedBy() <em>Caused By</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCausedBy()
	 * @generated
	 * @ordered
	 */
	protected EList causedBy = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TPFVerdictEventImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return Common_TestprofilePackage.eINSTANCE.getTPFVerdictEvent();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TPFVerdict getVerdict() {
		return verdict;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setVerdict(TPFVerdict newVerdict) {
		TPFVerdict oldVerdict = verdict;
		verdict = newVerdict == null ? VERDICT_EDEFAULT : newVerdict;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_TestprofilePackage.TPF_VERDICT_EVENT__VERDICT, oldVerdict, verdict));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TPFVerdictReason getReason() {
		return reason;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setReason(TPFVerdictReason newReason) {
		TPFVerdictReason oldReason = reason;
		reason = newReason == null ? REASON_EDEFAULT : newReason;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_TestprofilePackage.TPF_VERDICT_EVENT__REASON, oldReason, reason));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getCausedBy() {
		if (causedBy == null) {
			causedBy = new EObjectResolvingEList(TPFExecutionEvent.class, this, Common_TestprofilePackage.TPF_VERDICT_EVENT__CAUSED_BY);
		}
		return causedBy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case Common_TestprofilePackage.TPF_VERDICT_EVENT__EXECUTION_HISTORY:
					if (eContainer != null)
						msgs = eBasicRemoveFromContainer(msgs);
					return eBasicSetContainer(otherEnd, Common_TestprofilePackage.TPF_VERDICT_EVENT__EXECUTION_HISTORY, msgs);
				case Common_TestprofilePackage.TPF_VERDICT_EVENT__CHILDREN:
					return ((InternalEList)getChildren()).basicAdd(otherEnd, msgs);
				case Common_TestprofilePackage.TPF_VERDICT_EVENT__PARENT:
					if (eContainer != null)
						msgs = eBasicRemoveFromContainer(msgs);
					return eBasicSetContainer(otherEnd, Common_TestprofilePackage.TPF_VERDICT_EVENT__PARENT, msgs);
				default:
					return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case Common_TestprofilePackage.TPF_VERDICT_EVENT__EXECUTION_HISTORY:
					return eBasicSetContainer(null, Common_TestprofilePackage.TPF_VERDICT_EVENT__EXECUTION_HISTORY, msgs);
				case Common_TestprofilePackage.TPF_VERDICT_EVENT__CHILDREN:
					return ((InternalEList)getChildren()).basicRemove(otherEnd, msgs);
				case Common_TestprofilePackage.TPF_VERDICT_EVENT__PARENT:
					return eBasicSetContainer(null, Common_TestprofilePackage.TPF_VERDICT_EVENT__PARENT, msgs);
				case Common_TestprofilePackage.TPF_VERDICT_EVENT__PROPERTIES:
					return ((InternalEList)getProperties()).basicRemove(otherEnd, msgs);
				case Common_TestprofilePackage.TPF_VERDICT_EVENT__ANNOTATIONS:
					return ((InternalEList)getAnnotations()).basicRemove(otherEnd, msgs);
				case Common_TestprofilePackage.TPF_VERDICT_EVENT__EOBJECT_REFERENCES:
					return ((InternalEList)getEObjectReferences()).basicRemove(otherEnd, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
				case Common_TestprofilePackage.TPF_VERDICT_EVENT__EXECUTION_HISTORY:
					return ((InternalEObject)eContainer).eInverseRemove(this, Common_TestprofilePackage.TPF_EXECUTION_HISTORY__EXECUTION_EVENTS, TPFExecutionHistory.class, msgs);
				case Common_TestprofilePackage.TPF_VERDICT_EVENT__PARENT:
					return ((InternalEObject)eContainer).eInverseRemove(this, Common_TestprofilePackage.TPF_EXECUTION_EVENT__CHILDREN, TPFExecutionEvent.class, msgs);
				default:
					return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return ((InternalEObject)eContainer).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__ID:
				return getId();
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__DESCRIPTION:
				return getDescription();
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__NAME:
				return getName();
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__OWNER_ID:
				return getOwnerId();
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__TIMESTAMP:
				return new Long(getTimestamp());
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__TEXT:
				return getText();
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__EVENT_TYPE:
				return getEventType();
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__EXECUTION_HISTORY:
				return getExecutionHistory();
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__INTERACTION_FRAGMENT:
				if (resolve) return getInteractionFragment();
				return basicGetInteractionFragment();
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__CHILDREN:
				return getChildren();
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__PARENT:
				return getParent();
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__PROPERTIES:
				return getProperties();
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__ANNOTATIONS:
				return getAnnotations();
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__EOBJECT_REFERENCES:
				return getEObjectReferences();
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__VERDICT:
				return getVerdict();
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__REASON:
				return getReason();
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__CAUSED_BY:
				return getCausedBy();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__ID:
				setId((String)newValue);
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__DESCRIPTION:
				setDescription((String)newValue);
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__NAME:
				setName((String)newValue);
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__OWNER_ID:
				setOwnerId((String)newValue);
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__TIMESTAMP:
				setTimestamp(((Long)newValue).longValue());
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__TEXT:
				setText((String)newValue);
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__EVENT_TYPE:
				setEventType((String)newValue);
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__EXECUTION_HISTORY:
				setExecutionHistory((TPFExecutionHistory)newValue);
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__INTERACTION_FRAGMENT:
				setInteractionFragment((BVRInteractionFragment)newValue);
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__CHILDREN:
				getChildren().clear();
				getChildren().addAll((Collection)newValue);
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__PARENT:
				setParent((TPFExecutionEvent)newValue);
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__PROPERTIES:
				getProperties().clear();
				getProperties().addAll((Collection)newValue);
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__ANNOTATIONS:
				getAnnotations().clear();
				getAnnotations().addAll((Collection)newValue);
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__EOBJECT_REFERENCES:
				getEObjectReferences().clear();
				getEObjectReferences().addAll((Collection)newValue);
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__VERDICT:
				setVerdict((TPFVerdict)newValue);
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__REASON:
				setReason((TPFVerdictReason)newValue);
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__CAUSED_BY:
				getCausedBy().clear();
				getCausedBy().addAll((Collection)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__ID:
				setId(ID_EDEFAULT);
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__DESCRIPTION:
				setDescription(DESCRIPTION_EDEFAULT);
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__NAME:
				setName(NAME_EDEFAULT);
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__OWNER_ID:
				setOwnerId(OWNER_ID_EDEFAULT);
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__TIMESTAMP:
				setTimestamp(TIMESTAMP_EDEFAULT);
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__TEXT:
				setText(TEXT_EDEFAULT);
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__EVENT_TYPE:
				setEventType(EVENT_TYPE_EDEFAULT);
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__EXECUTION_HISTORY:
				setExecutionHistory((TPFExecutionHistory)null);
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__INTERACTION_FRAGMENT:
				setInteractionFragment((BVRInteractionFragment)null);
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__CHILDREN:
				getChildren().clear();
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__PARENT:
				setParent((TPFExecutionEvent)null);
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__PROPERTIES:
				getProperties().clear();
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__ANNOTATIONS:
				getAnnotations().clear();
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__EOBJECT_REFERENCES:
				getEObjectReferences().clear();
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__VERDICT:
				setVerdict(VERDICT_EDEFAULT);
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__REASON:
				setReason(REASON_EDEFAULT);
				return;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__CAUSED_BY:
				getCausedBy().clear();
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__ID:
				return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals(id);
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__DESCRIPTION:
				return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__OWNER_ID:
				return OWNER_ID_EDEFAULT == null ? ownerId != null : !OWNER_ID_EDEFAULT.equals(ownerId);
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__TIMESTAMP:
				return timestamp != TIMESTAMP_EDEFAULT;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__TEXT:
				return TEXT_EDEFAULT == null ? text != null : !TEXT_EDEFAULT.equals(text);
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__EVENT_TYPE:
				return EVENT_TYPE_EDEFAULT == null ? eventType != null : !EVENT_TYPE_EDEFAULT.equals(eventType);
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__EXECUTION_HISTORY:
				return getExecutionHistory() != null;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__INTERACTION_FRAGMENT:
				return interactionFragment != null;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__CHILDREN:
				return children != null && !children.isEmpty();
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__PARENT:
				return getParent() != null;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__PROPERTIES:
				return properties != null && !properties.isEmpty();
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__ANNOTATIONS:
				return annotations != null && !annotations.isEmpty();
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__EOBJECT_REFERENCES:
				return eObjectReferences != null && !eObjectReferences.isEmpty();
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__VERDICT:
				return verdict != VERDICT_EDEFAULT;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__REASON:
				return reason != REASON_EDEFAULT;
			case Common_TestprofilePackage.TPF_VERDICT_EVENT__CAUSED_BY:
				return causedBy != null && !causedBy.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (verdict: ");
		result.append(verdict);
		result.append(", reason: ");
		result.append(reason);
		result.append(')');
		return result.toString();
	}

} //TPFVerdictEventImpl
