/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: SDBPackage.java,v 1.7 2005/02/16 22:21:25 qiyanli Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.internal.sdb;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * <!-- begin-model-doc -->
 * Internal package, please do not extend or use.
 * The symptom data base is used to contain symptoms to be used by an analysis engine whne analyzing common base events
 * <!-- end-model-doc -->
 * @see org.eclipse.hyades.models.internal.sdb.SDBFactory
 * @generated
 */
public interface SDBPackage extends EPackage{
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "sdb";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.eclipse.org/hyades/models/SDB.xmi";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "SDB";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	SDBPackage eINSTANCE = org.eclipse.hyades.models.internal.sdb.impl.SDBPackageImpl.init();

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.internal.sdb.impl.SDBRuntimeImpl <em>Runtime</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.internal.sdb.impl.SDBRuntimeImpl
	 * @see org.eclipse.hyades.models.internal.sdb.impl.SDBPackageImpl#getSDBRuntime()
	 * @generated
	 */
	int SDB_RUNTIME = 0;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDB_RUNTIME__ID = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDB_RUNTIME__NAME = 1;

	/**
	 * The feature id for the '<em><b>Symptom Url</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDB_RUNTIME__SYMPTOM_URL = 2;

	/**
	 * The feature id for the '<em><b>Local External File Location</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDB_RUNTIME__LOCAL_EXTERNAL_FILE_LOCATION = 3;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDB_RUNTIME__DESCRIPTION = 4;

	/**
	 * The feature id for the '<em><b>Symptoms</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDB_RUNTIME__SYMPTOMS = 5;

	/**
	 * The feature id for the '<em><b>Solutions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDB_RUNTIME__SOLUTIONS = 6;

	/**
	 * The feature id for the '<em><b>Directives</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDB_RUNTIME__DIRECTIVES = 7;

	/**
	 * The number of structural features of the the '<em>Runtime</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDB_RUNTIME_FEATURE_COUNT = 8;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.internal.sdb.impl.SDBSymptomImpl <em>Symptom</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.internal.sdb.impl.SDBSymptomImpl
	 * @see org.eclipse.hyades.models.internal.sdb.impl.SDBPackageImpl#getSDBSymptom()
	 * @generated
	 */
	int SDB_SYMPTOM = 1;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDB_SYMPTOM__DESCRIPTION = 0;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDB_SYMPTOM__ID = 1;

	/**
	 * The feature id for the '<em><b>Solutions</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDB_SYMPTOM__SOLUTIONS = 2;

	/**
	 * The feature id for the '<em><b>Patterns</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDB_SYMPTOM__PATTERNS = 3;

	/**
	 * The number of structural features of the the '<em>Symptom</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDB_SYMPTOM_FEATURE_COUNT = 4;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.internal.sdb.impl.SDBMatchPatternImpl <em>Match Pattern</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.internal.sdb.impl.SDBMatchPatternImpl
	 * @see org.eclipse.hyades.models.internal.sdb.impl.SDBPackageImpl#getSDBMatchPattern()
	 * @generated
	 */
	int SDB_MATCH_PATTERN = 2;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDB_MATCH_PATTERN__NAME = 0;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDB_MATCH_PATTERN__VALUE = 1;

	/**
	 * The number of structural features of the the '<em>Match Pattern</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDB_MATCH_PATTERN_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.internal.sdb.impl.SDBSolutionImpl <em>Solution</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.internal.sdb.impl.SDBSolutionImpl
	 * @see org.eclipse.hyades.models.internal.sdb.impl.SDBPackageImpl#getSDBSolution()
	 * @generated
	 */
	int SDB_SOLUTION = 3;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDB_SOLUTION__DESCRIPTION = 0;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDB_SOLUTION__ID = 1;

	/**
	 * The feature id for the '<em><b>Directives</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDB_SOLUTION__DIRECTIVES = 2;

	/**
	 * The feature id for the '<em><b>Symptoms</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDB_SOLUTION__SYMPTOMS = 3;

	/**
	 * The number of structural features of the the '<em>Solution</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDB_SOLUTION_FEATURE_COUNT = 4;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.internal.sdb.impl.SDBDirectiveImpl <em>Directive</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.internal.sdb.impl.SDBDirectiveImpl
	 * @see org.eclipse.hyades.models.internal.sdb.impl.SDBPackageImpl#getSDBDirective()
	 * @generated
	 */
	int SDB_DIRECTIVE = 4;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDB_DIRECTIVE__ID = 0;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDB_DIRECTIVE__DESCRIPTION = 1;

	/**
	 * The feature id for the '<em><b>Directive String</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDB_DIRECTIVE__DIRECTIVE_STRING = 2;

	/**
	 * The feature id for the '<em><b>Solutions</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDB_DIRECTIVE__SOLUTIONS = 3;

	/**
	 * The number of structural features of the the '<em>Directive</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDB_DIRECTIVE_FEATURE_COUNT = 4;


	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.internal.sdb.SDBRuntime <em>Runtime</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Runtime</em>'.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBRuntime
	 * @generated
	 */
	EClass getSDBRuntime();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.internal.sdb.SDBRuntime#getId <em>Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Id</em>'.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBRuntime#getId()
	 * @see #getSDBRuntime()
	 * @generated
	 */
	EAttribute getSDBRuntime_Id();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.internal.sdb.SDBRuntime#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBRuntime#getName()
	 * @see #getSDBRuntime()
	 * @generated
	 */
	EAttribute getSDBRuntime_Name();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.internal.sdb.SDBRuntime#getSymptomUrl <em>Symptom Url</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Symptom Url</em>'.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBRuntime#getSymptomUrl()
	 * @see #getSDBRuntime()
	 * @generated
	 */
	EAttribute getSDBRuntime_SymptomUrl();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.internal.sdb.SDBRuntime#getLocalExternalFileLocation <em>Local External File Location</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Local External File Location</em>'.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBRuntime#getLocalExternalFileLocation()
	 * @see #getSDBRuntime()
	 * @generated
	 */
	EAttribute getSDBRuntime_LocalExternalFileLocation();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.internal.sdb.SDBRuntime#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBRuntime#getDescription()
	 * @see #getSDBRuntime()
	 * @generated
	 */
	EAttribute getSDBRuntime_Description();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.hyades.models.internal.sdb.SDBRuntime#getSymptoms <em>Symptoms</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Symptoms</em>'.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBRuntime#getSymptoms()
	 * @see #getSDBRuntime()
	 * @generated
	 */
	EReference getSDBRuntime_Symptoms();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.hyades.models.internal.sdb.SDBRuntime#getSolutions <em>Solutions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Solutions</em>'.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBRuntime#getSolutions()
	 * @see #getSDBRuntime()
	 * @generated
	 */
	EReference getSDBRuntime_Solutions();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.hyades.models.internal.sdb.SDBRuntime#getDirectives <em>Directives</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Directives</em>'.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBRuntime#getDirectives()
	 * @see #getSDBRuntime()
	 * @generated
	 */
	EReference getSDBRuntime_Directives();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.internal.sdb.SDBSymptom <em>Symptom</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Symptom</em>'.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBSymptom
	 * @generated
	 */
	EClass getSDBSymptom();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.internal.sdb.SDBSymptom#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBSymptom#getDescription()
	 * @see #getSDBSymptom()
	 * @generated
	 */
	EAttribute getSDBSymptom_Description();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.internal.sdb.SDBSymptom#getId <em>Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Id</em>'.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBSymptom#getId()
	 * @see #getSDBSymptom()
	 * @generated
	 */
	EAttribute getSDBSymptom_Id();

	/**
	 * Returns the meta object for the reference list '{@link org.eclipse.hyades.models.internal.sdb.SDBSymptom#getSolutions <em>Solutions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Solutions</em>'.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBSymptom#getSolutions()
	 * @see #getSDBSymptom()
	 * @generated
	 */
	EReference getSDBSymptom_Solutions();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.hyades.models.internal.sdb.SDBSymptom#getPatterns <em>Patterns</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Patterns</em>'.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBSymptom#getPatterns()
	 * @see #getSDBSymptom()
	 * @generated
	 */
	EReference getSDBSymptom_Patterns();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.internal.sdb.SDBMatchPattern <em>Match Pattern</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Match Pattern</em>'.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBMatchPattern
	 * @generated
	 */
	EClass getSDBMatchPattern();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.internal.sdb.SDBMatchPattern#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBMatchPattern#getName()
	 * @see #getSDBMatchPattern()
	 * @generated
	 */
	EAttribute getSDBMatchPattern_Name();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.internal.sdb.SDBMatchPattern#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBMatchPattern#getValue()
	 * @see #getSDBMatchPattern()
	 * @generated
	 */
	EAttribute getSDBMatchPattern_Value();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.internal.sdb.SDBSolution <em>Solution</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Solution</em>'.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBSolution
	 * @generated
	 */
	EClass getSDBSolution();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.internal.sdb.SDBSolution#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBSolution#getDescription()
	 * @see #getSDBSolution()
	 * @generated
	 */
	EAttribute getSDBSolution_Description();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.internal.sdb.SDBSolution#getId <em>Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Id</em>'.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBSolution#getId()
	 * @see #getSDBSolution()
	 * @generated
	 */
	EAttribute getSDBSolution_Id();

	/**
	 * Returns the meta object for the reference list '{@link org.eclipse.hyades.models.internal.sdb.SDBSolution#getDirectives <em>Directives</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Directives</em>'.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBSolution#getDirectives()
	 * @see #getSDBSolution()
	 * @generated
	 */
	EReference getSDBSolution_Directives();

	/**
	 * Returns the meta object for the reference list '{@link org.eclipse.hyades.models.internal.sdb.SDBSolution#getSymptoms <em>Symptoms</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Symptoms</em>'.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBSolution#getSymptoms()
	 * @see #getSDBSolution()
	 * @generated
	 */
	EReference getSDBSolution_Symptoms();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.internal.sdb.SDBDirective <em>Directive</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Directive</em>'.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBDirective
	 * @generated
	 */
	EClass getSDBDirective();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.internal.sdb.SDBDirective#getId <em>Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Id</em>'.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBDirective#getId()
	 * @see #getSDBDirective()
	 * @generated
	 */
	EAttribute getSDBDirective_Id();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.internal.sdb.SDBDirective#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBDirective#getDescription()
	 * @see #getSDBDirective()
	 * @generated
	 */
	EAttribute getSDBDirective_Description();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.internal.sdb.SDBDirective#getDirectiveString <em>Directive String</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Directive String</em>'.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBDirective#getDirectiveString()
	 * @see #getSDBDirective()
	 * @generated
	 */
	EAttribute getSDBDirective_DirectiveString();

	/**
	 * Returns the meta object for the reference list '{@link org.eclipse.hyades.models.internal.sdb.SDBDirective#getSolutions <em>Solutions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Solutions</em>'.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBDirective#getSolutions()
	 * @see #getSDBDirective()
	 * @generated
	 */
	EReference getSDBDirective_Solutions();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	SDBFactory getSDBFactory();

} //SDBPackage
