/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: SDBSymptom.java,v 1.7 2005/02/16 22:21:25 qiyanli Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.internal.sdb;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Symptom</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A symptom is a unique set of match criteria that can be used to identify a 
 * problem. The uniqueness of the symptom is up ot the instance provider.
 * 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.internal.sdb.SDBSymptom#getDescription <em>Description</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.internal.sdb.SDBSymptom#getId <em>Id</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.internal.sdb.SDBSymptom#getSolutions <em>Solutions</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.internal.sdb.SDBSymptom#getPatterns <em>Patterns</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.internal.sdb.SDBPackage#getSDBSymptom()
 * @model 
 * @generated
 */
public interface SDBSymptom extends EObject{
	/**
	 * Returns the value of the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Description</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * A human readable description of the problem is captured in this property. An example may be "system hangs after loading file X"
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Description</em>' attribute.
	 * @see #setDescription(String)
	 * @see org.eclipse.hyades.models.internal.sdb.SDBPackage#getSDBSymptom_Description()
	 * @model 
	 * @generated
	 */
	String getDescription();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.internal.sdb.SDBSymptom#getDescription <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Description</em>' attribute.
	 * @see #getDescription()
	 * @generated
	 */
	void setDescription(String value);

	/**
	 * Returns the value of the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Id</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * The id of a symptom uniquly identifies a symptom within a runtime. It is actually the only thing that must be unique within the  set of symptons for a given runtime.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Id</em>' attribute.
	 * @see #setId(String)
	 * @see org.eclipse.hyades.models.internal.sdb.SDBPackage#getSDBSymptom_Id()
	 * @model 
	 * @generated
	 */
	String getId();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.internal.sdb.SDBSymptom#getId <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Id</em>' attribute.
	 * @see #getId()
	 * @generated
	 */
	void setId(String value);

	/**
	 * Returns the value of the '<em><b>Solutions</b></em>' reference list.
	 * The list contents are of type {@link org.eclipse.hyades.models.internal.sdb.SDBSolution}.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.internal.sdb.SDBSolution#getSymptoms <em>Symptoms</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Solutions</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Solutions</em>' reference list.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBPackage#getSDBSymptom_Solutions()
	 * @see org.eclipse.hyades.models.internal.sdb.SDBSolution#getSymptoms
	 * @model type="org.eclipse.hyades.models.internal.sdb.SDBSolution" opposite="symptoms"
	 * @generated
	 */
	EList getSolutions();

	/**
	 * Returns the value of the '<em><b>Patterns</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.hyades.models.internal.sdb.SDBMatchPattern}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Patterns</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Patterns are process in sequence to determine a complete match for a given symptom.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Patterns</em>' containment reference list.
	 * @see org.eclipse.hyades.models.internal.sdb.SDBPackage#getSDBSymptom_Patterns()
	 * @model type="org.eclipse.hyades.models.internal.sdb.SDBMatchPattern" containment="true"
	 * @generated
	 */
	EList getPatterns();

} // SDBSymptom
