/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: TRCAggregatedObjectReference.java,v 1.10 2005/02/10 22:13:41 qiyanli Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.trace;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>TRC Aggregated Object Reference</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This will be used in HEAP_STATISTICS* collection modes. This reference object will be linked at class object level and it will look like a class to class reference.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCAggregatedObjectReference#getOwnerSize <em>Owner Size</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCAggregatedObjectReference#getTargetSize <em>Target Size</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCAggregatedObjectReference#getCount <em>Count</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCAggregatedObjectReference()
 * @model 
 * @generated
 */
public interface TRCAggregatedObjectReference extends TRCObjectReference{
	/**
	 * Returns the value of the '<em><b>Owner Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Owner Size</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * the total size of all owners
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Owner Size</em>' attribute.
	 * @see #setOwnerSize(int)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCAggregatedObjectReference_OwnerSize()
	 * @model 
	 * @generated
	 */
	int getOwnerSize();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCAggregatedObjectReference#getOwnerSize <em>Owner Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Owner Size</em>' attribute.
	 * @see #getOwnerSize()
	 * @generated
	 */
	void setOwnerSize(int value);

	/**
	 * Returns the value of the '<em><b>Target Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Target Size</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * the total size of all owners
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Target Size</em>' attribute.
	 * @see #setTargetSize(int)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCAggregatedObjectReference_TargetSize()
	 * @model 
	 * @generated
	 */
	int getTargetSize();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCAggregatedObjectReference#getTargetSize <em>Target Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Target Size</em>' attribute.
	 * @see #getTargetSize()
	 * @generated
	 */
	void setTargetSize(int value);

	/**
	 * Returns the value of the '<em><b>Count</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Count</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * the number of references between owner objects to target objects collapsed in this reference at class level
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Count</em>' attribute.
	 * @see #setCount(int)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCAggregatedObjectReference_Count()
	 * @model 
	 * @generated
	 */
	int getCount();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCAggregatedObjectReference#getCount <em>Count</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Count</em>' attribute.
	 * @see #getCount()
	 * @generated
	 */
	void setCount(int value);

} // TRCAggregatedObjectReference
