/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: TRCHeapRoot.java,v 1.10 2005/02/10 22:13:41 qiyanli Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.trace;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>TRC Heap Root</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCHeapRoot#getType <em>Type</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCHeapRoot#getFrame <em>Frame</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCHeapRoot#getHeapDump <em>Heap Dump</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCHeapRoot#getThread <em>Thread</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCHeapRoot#getObject <em>Object</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCHeapRoot()
 * @model 
 * @generated
 */
public interface TRCHeapRoot extends EObject{
	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute.
	 * The literals are from the enumeration {@link org.eclipse.hyades.models.trace.TRCGCRootType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see org.eclipse.hyades.models.trace.TRCGCRootType
	 * @see #setType(TRCGCRootType)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCHeapRoot_Type()
	 * @model 
	 * @generated
	 */
	TRCGCRootType getType();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCHeapRoot#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' attribute.
	 * @see org.eclipse.hyades.models.trace.TRCGCRootType
	 * @see #getType()
	 * @generated
	 */
	void setType(TRCGCRootType value);

	/**
	 * Returns the value of the '<em><b>Frame</b></em>' attribute.
	 * The default value is <code>"-1"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Frame</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * -1 == unknown
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Frame</em>' attribute.
	 * @see #setFrame(int)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCHeapRoot_Frame()
	 * @model default="-1"
	 * @generated
	 */
	int getFrame();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCHeapRoot#getFrame <em>Frame</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Frame</em>' attribute.
	 * @see #getFrame()
	 * @generated
	 */
	void setFrame(int value);

	/**
	 * Returns the value of the '<em><b>Heap Dump</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.trace.TRCHeapDump#getGcRoots <em>Gc Roots</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Heap Dump</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Heap Dump</em>' container reference.
	 * @see #setHeapDump(TRCHeapDump)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCHeapRoot_HeapDump()
	 * @see org.eclipse.hyades.models.trace.TRCHeapDump#getGcRoots
	 * @model opposite="gcRoots" required="true"
	 * @generated
	 */
	TRCHeapDump getHeapDump();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCHeapRoot#getHeapDump <em>Heap Dump</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Heap Dump</em>' container reference.
	 * @see #getHeapDump()
	 * @generated
	 */
	void setHeapDump(TRCHeapDump value);

	/**
	 * Returns the value of the '<em><b>Thread</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Thread</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Thread</em>' reference.
	 * @see #setThread(TRCThread)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCHeapRoot_Thread()
	 * @model 
	 * @generated
	 */
	TRCThread getThread();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCHeapRoot#getThread <em>Thread</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Thread</em>' reference.
	 * @see #getThread()
	 * @generated
	 */
	void setThread(TRCThread value);

	/**
	 * Returns the value of the '<em><b>Object</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Object</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Object</em>' reference.
	 * @see #setObject(TRCObject)
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCHeapRoot_Object()
	 * @model 
	 * @generated
	 */
	TRCObject getObject();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCHeapRoot#getObject <em>Object</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Object</em>' reference.
	 * @see #getObject()
	 * @generated
	 */
	void setObject(TRCObject value);

} // TRCHeapRoot
