/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: TraceFactory.java,v 1.16 2005/02/10 22:13:41 qiyanli Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.trace;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see org.eclipse.hyades.models.trace.TracePackage
 * @generated
 */
public interface TraceFactory extends EFactory{
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	TraceFactory eINSTANCE = new org.eclipse.hyades.models.trace.impl.TraceFactoryImpl();

	/**
	 * Returns a new object of class '<em>TRC Object</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Object</em>'.
	 * @generated
	 */
	TRCObject createTRCObject();

	/**
	 * Returns a new object of class '<em>TRC Class</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Class</em>'.
	 * @generated
	 */
	TRCClass createTRCClass();

	/**
	 * Returns a new object of class '<em>TRC Method Invocation</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Method Invocation</em>'.
	 * @generated
	 */
	TRCMethodInvocation createTRCMethodInvocation();

	/**
	 * Returns a new object of class '<em>TRC Process</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Process</em>'.
	 * @generated
	 */
	TRCProcess createTRCProcess();

	/**
	 * Returns a new object of class '<em>TRC Thread</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Thread</em>'.
	 * @generated
	 */
	TRCThread createTRCThread();

	/**
	 * Returns a new object of class '<em>TRC Method</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Method</em>'.
	 * @generated
	 */
	TRCMethod createTRCMethod();

	/**
	 * Returns a new object of class '<em>TRC Package</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Package</em>'.
	 * @generated
	 */
	TRCPackage createTRCPackage();

	/**
	 * Returns a new object of class '<em>TRC Collection Boundary</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Collection Boundary</em>'.
	 * @generated
	 */
	TRCCollectionBoundary createTRCCollectionBoundary();

	/**
	 * Returns a new object of class '<em>TRC Class Loader</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Class Loader</em>'.
	 * @generated
	 */
	TRCClassLoader createTRCClassLoader();

	/**
	 * Returns a new object of class '<em>TRC Source Info</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Source Info</em>'.
	 * @generated
	 */
	TRCSourceInfo createTRCSourceInfo();

	/**
	 * Returns a new object of class '<em>TRC Heap Object</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Heap Object</em>'.
	 * @generated
	 */
	TRCHeapObject createTRCHeapObject();

	/**
	 * Returns a new object of class '<em>TRC Full Trace Object</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Full Trace Object</em>'.
	 * @generated
	 */
	TRCFullTraceObject createTRCFullTraceObject();

	/**
	 * Returns a new object of class '<em>TRC Trace Object</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Trace Object</em>'.
	 * @generated
	 */
	TRCTraceObject createTRCTraceObject();

	/**
	 * Returns a new object of class '<em>TRC Full Heap Object</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Full Heap Object</em>'.
	 * @generated
	 */
	TRCFullHeapObject createTRCFullHeapObject();

	/**
	 * Returns a new object of class '<em>TRC Object Reference</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Object Reference</em>'.
	 * @generated
	 */
	TRCObjectReference createTRCObjectReference();

	/**
	 * Returns a new object of class '<em>TRC Heap Dump</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Heap Dump</em>'.
	 * @generated
	 */
	TRCHeapDump createTRCHeapDump();

	/**
	 * Returns a new object of class '<em>TRC Aggregated Method Invocation</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Aggregated Method Invocation</em>'.
	 * @generated
	 */
	TRCAggregatedMethodInvocation createTRCAggregatedMethodInvocation();

	/**
	 * Returns a new object of class '<em>TRC Full Method Invocation</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Full Method Invocation</em>'.
	 * @generated
	 */
	TRCFullMethodInvocation createTRCFullMethodInvocation();

	/**
	 * Returns a new object of class '<em>TRC Heap Root</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Heap Root</em>'.
	 * @generated
	 */
	TRCHeapRoot createTRCHeapRoot();

	/**
	 * Returns a new object of class '<em>TRC Array Class</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Array Class</em>'.
	 * @generated
	 */
	TRCArrayClass createTRCArrayClass();

	/**
	 * Returns a new object of class '<em>TRC Aggregated Object Reference</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Aggregated Object Reference</em>'.
	 * @generated
	 */
	TRCAggregatedObjectReference createTRCAggregatedObjectReference();

	/**
	 * Returns a new object of class '<em>TRC Thread Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Thread Event</em>'.
	 * @generated
	 */
	TRCThreadEvent createTRCThreadEvent();

	/**
	 * Returns a new object of class '<em>TRC Thread Sleeping Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Thread Sleeping Event</em>'.
	 * @generated
	 */
	TRCThreadSleepingEvent createTRCThreadSleepingEvent();

	/**
	 * Returns a new object of class '<em>TRC Thread Waiting For Object Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Thread Waiting For Object Event</em>'.
	 * @generated
	 */
	TRCThreadWaitingForObjectEvent createTRCThreadWaitingForObjectEvent();

	/**
	 * Returns a new object of class '<em>TRC Thread Waiting For Lock Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Thread Waiting For Lock Event</em>'.
	 * @generated
	 */
	TRCThreadWaitingForLockEvent createTRCThreadWaitingForLockEvent();

	/**
	 * Returns a new object of class '<em>TRC Thread Running Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Thread Running Event</em>'.
	 * @generated
	 */
	TRCThreadRunningEvent createTRCThreadRunningEvent();

	/**
	 * Returns a new object of class '<em>TRC Thread Dead Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Thread Dead Event</em>'.
	 * @generated
	 */
	TRCThreadDeadEvent createTRCThreadDeadEvent();

	/**
	 * Returns a new object of class '<em>TRC Method With LL Data</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Method With LL Data</em>'.
	 * @generated
	 */
	TRCMethodWithLLData createTRCMethodWithLLData();

	/**
	 * Returns a new object of class '<em>TRC Source Info With LL Data</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Source Info With LL Data</em>'.
	 * @generated
	 */
	TRCSourceInfoWithLLData createTRCSourceInfoWithLLData();

	/**
	 * Returns a new object of class '<em>TRC Line Coverage Data</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Line Coverage Data</em>'.
	 * @generated
	 */
	TRCLineCoverageData createTRCLineCoverageData();

	/**
	 * Returns a new object of class '<em>TRC Object Value</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Object Value</em>'.
	 * @generated
	 */
	TRCObjectValue createTRCObjectValue();

	/**
	 * Returns a new object of class '<em>TRC Input Output Container</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Input Output Container</em>'.
	 * @generated
	 */
	TRCInputOutputContainer createTRCInputOutputContainer();

	/**
	 * Returns a new object of class '<em>TRC Caller Callee Invocation Info</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Caller Callee Invocation Info</em>'.
	 * @generated
	 */
	TRCCallerCalleeInvocationInfo createTRCCallerCalleeInvocationInfo();

	/**
	 * Returns a new object of class '<em>TRC Typed Object Value</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Typed Object Value</em>'.
	 * @generated
	 */
	TRCTypedObjectValue createTRCTypedObjectValue();

	/**
	 * Returns a new object of class '<em>TRC Lock Access</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Lock Access</em>'.
	 * @generated
	 */
	TRCLockAccess createTRCLockAccess();

	/**
	 * Returns a new object of class '<em>TRC Line Performance Data</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Line Performance Data</em>'.
	 * @generated
	 */
	TRCLinePerformanceData createTRCLinePerformanceData();

	/**
	 * Returns a new object of class '<em>TRC Object Allocation Site</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Object Allocation Site</em>'.
	 * @generated
	 */
	TRCObjectAllocationSite createTRCObjectAllocationSite();

	/**
	 * Returns a new object of class '<em>TRC Thread Dead Lock Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>TRC Thread Dead Lock Event</em>'.
	 * @generated
	 */
	TRCThreadDeadLockEvent createTRCThreadDeadLockEvent();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	TracePackage getTracePackage();

} //TraceFactory
