/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: TRCLLDataImpl.java,v 1.12 2005/02/10 22:13:41 qiyanli Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.trace.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.hyades.models.trace.TRCLLData;
import org.eclipse.hyades.models.trace.TRCMethodWithLLData;
import org.eclipse.hyades.models.trace.TracePackage;
import org.eclipse.hyades.models.trace.util.LLUnitData;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>TRCLL Data</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.trace.impl.TRCLLDataImpl#getSummaryUnits <em>Summary Units</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.impl.TRCLLDataImpl#getSummaryNonzero <em>Summary Nonzero</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.impl.TRCLLDataImpl#getTypeId <em>Type Id</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.impl.TRCLLDataImpl#getHeadings <em>Headings</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.trace.impl.TRCLLDataImpl#getMethod <em>Method</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class TRCLLDataImpl extends EObjectImpl implements TRCLLData {
	/**
	 * The default value of the '{@link #getSummaryUnits() <em>Summary Units</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSummaryUnits()
	 * @generated
	 * @ordered
	 */
	protected static final int SUMMARY_UNITS_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getSummaryUnits() <em>Summary Units</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSummaryUnits()
	 * @generated
	 * @ordered
	 */
	protected int summaryUnits = SUMMARY_UNITS_EDEFAULT;

	/**
	 * The default value of the '{@link #getSummaryNonzero() <em>Summary Nonzero</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSummaryNonzero()
	 * @generated
	 * @ordered
	 */
	protected static final int SUMMARY_NONZERO_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getSummaryNonzero() <em>Summary Nonzero</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSummaryNonzero()
	 * @generated
	 * @ordered
	 */
	protected int summaryNonzero = SUMMARY_NONZERO_EDEFAULT;

	/**
	 * The default value of the '{@link #getTypeId() <em>Type Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTypeId()
	 * @generated
	 * @ordered
	 */
	protected static final String TYPE_ID_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getTypeId() <em>Type Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTypeId()
	 * @generated
	 * @ordered
	 */
	protected String typeId = TYPE_ID_EDEFAULT;

	/**
	 * The default value of the '{@link #getHeadings() <em>Headings</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHeadings()
	 * @generated
	 * @ordered
	 */
	protected static final String HEADINGS_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getHeadings() <em>Headings</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHeadings()
	 * @generated
	 * @ordered
	 */
	protected String headings = HEADINGS_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TRCLLDataImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return TracePackage.eINSTANCE.getTRCLLData();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getSummaryUnits() {
		return summaryUnits;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSummaryUnits(int newSummaryUnits) {
		int oldSummaryUnits = summaryUnits;
		summaryUnits = newSummaryUnits;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TracePackage.TRCLL_DATA__SUMMARY_UNITS, oldSummaryUnits, summaryUnits));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getSummaryNonzero() {
		return summaryNonzero;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSummaryNonzero(int newSummaryNonzero) {
		int oldSummaryNonzero = summaryNonzero;
		summaryNonzero = newSummaryNonzero;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TracePackage.TRCLL_DATA__SUMMARY_NONZERO, oldSummaryNonzero, summaryNonzero));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getTypeId() {
		return typeId;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTypeId(String newTypeId) {
		String oldTypeId = typeId;
		typeId = newTypeId;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TracePackage.TRCLL_DATA__TYPE_ID, oldTypeId, typeId));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getHeadings() {
		return headings;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setHeadings(String newHeadings) {
		String oldHeadings = headings;
		headings = newHeadings;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TracePackage.TRCLL_DATA__HEADINGS, oldHeadings, headings));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TRCMethodWithLLData getMethod() {
		if (eContainerFeatureID != TracePackage.TRCLL_DATA__METHOD) return null;
		return (TRCMethodWithLLData)eContainer;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMethod(TRCMethodWithLLData newMethod) {
		if (newMethod != eContainer || (eContainerFeatureID != TracePackage.TRCLL_DATA__METHOD && newMethod != null)) {
			if (EcoreUtil.isAncestor(this, newMethod))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newMethod != null)
				msgs = ((InternalEObject)newMethod).eInverseAdd(this, TracePackage.TRC_METHOD_WITH_LL_DATA__LL_DATA, TRCMethodWithLLData.class, msgs);
			msgs = eBasicSetContainer((InternalEObject)newMethod, TracePackage.TRCLL_DATA__METHOD, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TracePackage.TRCLL_DATA__METHOD, newMethod, newMethod));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getUnitCount() {
		// TODO: implement this method
		// Ensure that you remove @generated or mark it @generated NOT
		throw new UnsupportedOperationException();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LLUnitData getUnitData(int unitNumber, LLUnitData instance) {
		// TODO: implement this method
		// Ensure that you remove @generated or mark it @generated NOT
		throw new UnsupportedOperationException();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean hasCountInfo() {
		// TODO: implement this method
		// Ensure that you remove @generated or mark it @generated NOT
		throw new UnsupportedOperationException();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean hasAccumulatedTimeInfo() {
		// TODO: implement this method
		// Ensure that you remove @generated or mark it @generated NOT
		throw new UnsupportedOperationException();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case TracePackage.TRCLL_DATA__METHOD:
					if (eContainer != null)
						msgs = eBasicRemoveFromContainer(msgs);
					return eBasicSetContainer(otherEnd, TracePackage.TRCLL_DATA__METHOD, msgs);
				default:
					return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case TracePackage.TRCLL_DATA__METHOD:
					return eBasicSetContainer(null, TracePackage.TRCLL_DATA__METHOD, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
				case TracePackage.TRCLL_DATA__METHOD:
					return ((InternalEObject)eContainer).eInverseRemove(this, TracePackage.TRC_METHOD_WITH_LL_DATA__LL_DATA, TRCMethodWithLLData.class, msgs);
				default:
					return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return ((InternalEObject)eContainer).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case TracePackage.TRCLL_DATA__SUMMARY_UNITS:
				return new Integer(getSummaryUnits());
			case TracePackage.TRCLL_DATA__SUMMARY_NONZERO:
				return new Integer(getSummaryNonzero());
			case TracePackage.TRCLL_DATA__TYPE_ID:
				return getTypeId();
			case TracePackage.TRCLL_DATA__HEADINGS:
				return getHeadings();
			case TracePackage.TRCLL_DATA__METHOD:
				return getMethod();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case TracePackage.TRCLL_DATA__SUMMARY_UNITS:
				setSummaryUnits(((Integer)newValue).intValue());
				return;
			case TracePackage.TRCLL_DATA__SUMMARY_NONZERO:
				setSummaryNonzero(((Integer)newValue).intValue());
				return;
			case TracePackage.TRCLL_DATA__TYPE_ID:
				setTypeId((String)newValue);
				return;
			case TracePackage.TRCLL_DATA__HEADINGS:
				setHeadings((String)newValue);
				return;
			case TracePackage.TRCLL_DATA__METHOD:
				setMethod((TRCMethodWithLLData)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case TracePackage.TRCLL_DATA__SUMMARY_UNITS:
				setSummaryUnits(SUMMARY_UNITS_EDEFAULT);
				return;
			case TracePackage.TRCLL_DATA__SUMMARY_NONZERO:
				setSummaryNonzero(SUMMARY_NONZERO_EDEFAULT);
				return;
			case TracePackage.TRCLL_DATA__TYPE_ID:
				setTypeId(TYPE_ID_EDEFAULT);
				return;
			case TracePackage.TRCLL_DATA__HEADINGS:
				setHeadings(HEADINGS_EDEFAULT);
				return;
			case TracePackage.TRCLL_DATA__METHOD:
				setMethod((TRCMethodWithLLData)null);
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case TracePackage.TRCLL_DATA__SUMMARY_UNITS:
				return summaryUnits != SUMMARY_UNITS_EDEFAULT;
			case TracePackage.TRCLL_DATA__SUMMARY_NONZERO:
				return summaryNonzero != SUMMARY_NONZERO_EDEFAULT;
			case TracePackage.TRCLL_DATA__TYPE_ID:
				return TYPE_ID_EDEFAULT == null ? typeId != null : !TYPE_ID_EDEFAULT.equals(typeId);
			case TracePackage.TRCLL_DATA__HEADINGS:
				return HEADINGS_EDEFAULT == null ? headings != null : !HEADINGS_EDEFAULT.equals(headings);
			case TracePackage.TRCLL_DATA__METHOD:
				return getMethod() != null;
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (summaryUnits: ");
		result.append(summaryUnits);
		result.append(", summaryNonzero: ");
		result.append(summaryNonzero);
		result.append(", typeId: ");
		result.append(typeId);
		result.append(", headings: ");
		result.append(headings);
		result.append(')');
		return result.toString();
	}

} //TRCLLDataImpl
