/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: QueryFactoryImpl.java,v 1.4 2005/02/16 22:21:31 qiyanli Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
package org.eclipse.hyades.resources.database.internal.impl;

import org.eclipse.hyades.resources.database.internal.ObjectQuery;
import org.eclipse.hyades.resources.database.internal.QueryFactory;
import org.eclipse.hyades.resources.database.internal.ReferenceQuery;
/**
 * This class implements the QueryFactory interface.
 */
public class QueryFactoryImpl implements QueryFactory {
	/**
	 * Constructor for QueryFactoryImpl.
	 */
	public QueryFactoryImpl() {
		super();
	}

	/**
	 * @see org.eclipse.hyades.resources.database.internal.QueryFactory#createObjectQuery()
	 */
	public ObjectQuery createObjectQuery() {
		return new ObjectQueryImpl();
	}

	/**
	 * @see org.eclipse.hyades.resources.database.internal.QueryFactory#createReferenceQuery()
	 */
	public ReferenceQuery createReferenceQuery() {
		return new ReferenceQueryImpl();
	}
} // QueryFactoryImpl
