/*******************************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: IForm.java,v 1.4 2005/02/16 22:22:05 qiyanli Exp $
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.hyades.test.ui.internal.editor.form.base;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;

public interface IForm {
public void commitChanges(boolean onSave);
public Control createControl(Composite parent);
public void dispose();
public boolean doGlobalAction(String actionId);
public void expandTo(Object object);
public Control getControl();
public FormWidgetFactory getFactory();
public Color getHeadingBackground();
public Color getHeadingForeground();
public Image getHeadingImage();
public String getHeadingText();
public void initialize(Object model);
public boolean isHeadingVisible();
public void registerSection(FormSection section);
public void setFocus();
public void setHeadingBackground(Color newHeadingBackground);
public void setHeadingForeground(Color newHeadingForeground);
public void setHeadingImage(Image headingImage);
public void setHeadingVisible(boolean newHeadingVisible);
public void setHeadingText(String heading);
public void update();
}
