/*******************************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: TestCaseType2.java,v 1.5 2005/02/16 22:24:05 qiyanli Exp $
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.hyades.ui.sample.wizard;

import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.ui.IWorkbench;

import org.eclipse.hyades.models.common.facades.behavioral.ITestSuite;
import org.eclipse.hyades.models.common.testprofile.Common_TestprofileFactory;
import org.eclipse.hyades.models.common.testprofile.TPFTestCase;
import org.eclipse.hyades.models.common.testprofile.TPFTestSuite;
import org.eclipse.hyades.test.ui.wizard.ITestCaseWizard;

/**
 * @author marcelop
 * @since 
 */
public class TestCaseType2 
extends Wizard implements ITestCaseWizard
{
	private TPFTestSuite testSuite;
	private NameWizardPage nameWizardPage;
	
	/**
	 * Constructor for TestCaseType1
	 */
	public TestCaseType2()
	{
		super();
		setWindowTitle("New Test Case");
	}

	/**
	 * @see org.eclipse.ui.IWorkbenchWizard#init(org.eclipse.ui.IWorkbench, org.eclipse.jface.viewers.IStructuredSelection)
	 */
	public void init(IWorkbench workbench, IStructuredSelection selection)
	{
		testSuite = (TPFTestSuite)selection.getFirstElement();
	}

	/**
	 * @see org.eclipse.jface.wizard.IWizard#addPages()
	 */
	public void addPages()
	{
		nameWizardPage = new NameWizardPage("namePage");
		nameWizardPage.setTitle("Type2 Test Case");
		nameWizardPage.setDescription("Defines the name of the new test case\nof the test suite '" + testSuite.getName() + "'.");
		addPage(nameWizardPage);
	}

	/**
	 * @see org.eclipse.jface.wizard.IWizard#performFinish()
	 */
	public boolean performFinish()
	{
		TPFTestCase testCase = Common_TestprofileFactory.eINSTANCE.createTPFTestCase();
		testCase.setName(nameWizardPage.getTestCaseName());
		testCase.setType("testCaseType2");
		
		testSuite.getTestCases().add(testCase);
		
		return true;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.hyades.test.ui.wizard.ITestCaseWizard#setTestSuite(org.eclipse.hyades.models.common.facades.behavioral.ITestSuite)
	 */
	public void setTestSuite(ITestSuite testSuite_) {
		if (testSuite_ instanceof TPFTestSuite)
			testSuite = (TPFTestSuite)testSuite_;
	}
}
